package com.localhost.grok.concurrentcy2;



import android.app.Notification;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Environment;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;
import android.util.Log;

import java.io.File;
import java.io.IOException;

/**
 * Created by grok on 5/5/16.
 */
public class MusicService extends Service implements MediaPlayer.OnPreparedListener{
    private static final String TAG = null;
    MediaPlayer player;
    public IBinder onBind(Intent arg0) {

        return null;
    }
    @Override
    public void onCreate() {
        super.onCreate();
        player = new MediaPlayer();

    }
    public int onStartCommand(Intent intent, int flags, int startId) {
        String filename=intent.getStringExtra("filename");
        String path = Environment
                .getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS)+"/"+filename;
        Log.e("file", " " + path);
        try {
            player.setDataSource(path);
            player.setLooping(true); // Set looping
            player.setOnPreparedListener(this);
            player.prepareAsync();

        } catch (IOException e) {
            e.printStackTrace();
            Log.e("player error", " "+e.getMessage());
        }


        NotificationCompat.Builder mBuilder=
                new NotificationCompat.Builder(this)
                        .setSmallIcon(R.mipmap.
                                        ic_launcher
                        )
                        .setContentTitle("Song in progress")
                        .setContentText(filename);
        Intent notificationIntent = new Intent(this, MainActivity.class);

        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);
        mBuilder.setContentIntent(pendingIntent);
        Notification fullNotif = mBuilder.build();
        startForeground(42, fullNotif);

        return START_STICKY;
    }


    public IBinder onUnBind(Intent arg0) {
        // TO DO Auto-generated method
        return null;
    }

    public void onStop() {

    }
    public void onPause() {

    }
    @Override
    public void onDestroy() {
        player.stop();
        player.release();
    }

    @Override
    public void onLowMemory() {

    }

    @Override
    public void onPrepared(MediaPlayer mp) {
        mp.start();
        player.setVolume(100,100);
    }
}
