package com.localhost.grok.concurrentcy2;

import android.os.AsyncTask;
import android.os.Binder;
import android.os.SystemClock;
import android.util.Log;

/**
 * Created by admin on 02.05.16.
 */
public class SimpleBinder extends Binder {
    MyListener listener;
    private String loadedData;
    private boolean dataLoaded;


    public interface MyListener{
        public void dataLoaded();
    }

    public void attach(MyListener listener)
    {
        this.listener=listener;
    }

    public void detach()
    {
        this.listener=null;
    }

    public void cacheData()
    {


            new myLoader().execute();



    }

    public void onDestroy()
    {
        listener=null;
    }

    public String loadCachedData()
    {
        return loadedData;
    }
    private class myLoader extends AsyncTask<String,Void,Void>


    {

        @Override
        protected Void doInBackground(String... params) {
            SystemClock.sleep(5000);
            return null;
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);
            doSmth();
        }
    }

    private void doSmth()
    {
        loadedData="superData";
        dataLoaded=true;
        informListeners();
    }


    public void loadData()
    {
        if (dataLoaded)
        {
            informListeners();
        }
        else
        {
            cacheData();
        }

    }

    private void informListeners()
    {

        if (listener!=null)
        {
            listener.dataLoaded();
            Log.e("service", "going to inform listeners");
        }
    }
}
