package com.localhost.grok.concurrentcy2;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.support.annotation.Nullable;
import android.util.Log;

import java.io.File;

/**
 * Created by grok on 4/28/16.
 */
public class SimpleBindService extends Service {
    private String loadedData;
    private SimpleBinder binder;
    public SimpleBindService() {
        super();


    }


    private String data;




    @Override
    public void onCreate() {
        super.onCreate();
        binder = new SimpleBinder();
        binder.cacheData();
        Log.e("Service", "created");

    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        binder.onDestroy();
    }

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return binder;
    }

    @Override
    public File getDatabasePath(String name) {
        return super.getDatabasePath(name);
    }


    public String getData()
    {
        return binder.loadCachedData();
    }











}
